3 USAGE
='[help|start|bad|good|new|old|terms|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE
='git bisect help
5 print this long help message.
6 git bisect start [--term-{old,good}=<term> --term-{new,bad}=<term>]
7 [--no-checkout] [<bad> [<good>...]] [--] [<pathspec>...]
8 reset bisect state and start bisection.
9 git bisect (bad|new) [<rev>]
10 mark <rev> a known-bad revision/
11 a revision after change in a given property.
12 git bisect (good|old) [<rev>...]
13 mark <rev>... known-good revisions/
14 revisions before change in a given property.
15 git bisect terms [--term-good | --term-bad]
16 show the terms used for old and new commits (default: bad, good)
17 git bisect skip [(<rev>|<range>)...]
18 mark <rev>... untestable revisions.
20 find next bisection to test and check it out.
21 git bisect reset [<commit>]
22 finish bisection search and go back to commit.
24 show bisect status in gitk.
25 git bisect replay <logfile>
29 git bisect run <cmd>...
30 use <cmd>... to automatically bisect.
32 Please use "git help bisect" to get the full man page.'
37 _x40
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
38 _x40
="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
44 if test -f "$GIT_DIR/BISECT_HEAD"
53 test -s "$GIT_DIR/BISECT_START" ||
{
54 gettextln
"You need to start by \"git bisect start\"" >&2
57 # TRANSLATORS: Make sure to include [Y] and [n] in your
58 # translation. The program will only accept English input
60 gettext "Do you want me to do it for you [Y/n]? " >&2
75 # Check for one bad and then some good revisions.
79 case "$arg" in --) has_double_dash
=1; break ;; esac
81 orig_args
=$
(git rev-parse
--sq-quote "$@")
86 if test "z$(git rev-parse --is-bare-repository)" != zfalse
92 while [ $# -gt 0 ]; do
102 --term-good|
--term-old)
107 --term-good=*|
--term-old=*)
111 --term-bad|
--term-new)
116 --term-bad=*|
--term-new=*)
121 die
"$(eval_gettext "unrecognised option
: '\$arg'")" ;;
123 rev=$
(git rev-parse
-q --verify "$arg^{commit}") ||
{
124 test $has_double_dash -eq 1 &&
125 die
"$(eval_gettext "'\$arg' does not appear to be a valid revision
")"
136 # The user ran "git bisect start <sha1>
137 # <sha1>", hence did not explicitly specify
138 # the terms, but we are already starting to
139 # set references named with the default terms,
140 # and won't be able to change afterwards.
144 0) state
=$TERM_BAD ; bad_seen
=1 ;;
145 *) state
=$TERM_GOOD ;;
147 eval="$eval bisect_write '$state' '$rev' 'nolog' &&"
152 head=$
(GIT_DIR
="$GIT_DIR" git symbolic-ref
-q HEAD
) ||
153 head=$
(GIT_DIR
="$GIT_DIR" git rev-parse
--verify HEAD
) ||
154 die
"$(gettext "Bad HEAD
- I need a HEAD
")"
157 # Check if we are bisecting.
160 if test -s "$GIT_DIR/BISECT_START"
162 # Reset to the rev from where we started.
163 start_head
=$
(cat "$GIT_DIR/BISECT_START")
164 if test "z$mode" != "z--no-checkout"
166 git checkout
"$start_head" -- ||
167 die
"$(eval_gettext "Checking out
'\$start_head' failed. Try
'git bisect reset <valid-branch>'.
")"
170 # Get rev from where we start.
173 # This error message should only be triggered by
174 # cogito usage, and cogito users should understand
175 # it relates to cg-seek.
176 [ -s "$GIT_DIR/head-name" ] &&
177 die
"$(gettext "won
't bisect on cg-seek'ed tree
")"
178 start_head
="${head#refs/heads/}"
181 die
"$(gettext "Bad HEAD
- strange symbolic ref
")"
187 # Get rid of any old bisect state.
189 git bisect--helper
--bisect-clean-state ||
exit
193 # In case of mistaken revs or checkout error, or signals received,
194 # "bisect_auto_next" below may exit or misbehave.
195 # We have to trap this to be able to clean up using
196 # "bisect_clean_state".
198 trap 'git bisect--helper --bisect-clean-state' 0
199 trap 'exit 255' 1 2 3 15
202 # Write new start state.
204 echo "$start_head" >"$GIT_DIR/BISECT_START" && {
205 test "z$mode" != "z--no-checkout" ||
206 git update-ref
--no-deref BISECT_HEAD
"$start_head"
208 git rev-parse
--sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
210 if test $must_write_terms -eq 1
212 git bisect--helper
--write-terms "$TERM_BAD" "$TERM_GOOD" ||
exit
214 echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" ||
exit
216 # Check if we can proceed to the next bisect state.
231 tag
="$state"-"$rev" ;;
233 die
"$(eval_gettext "Bad bisect_write argument
: \
$state")" ;;
235 git update-ref
"refs/bisect/$tag" "$rev" ||
exit
236 echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
237 test -n "$nolog" ||
echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
246 revs
=$
(git rev-list
"$arg") || die
"$(eval_gettext "Bad
rev input
: \
$arg")" ;;
248 revs
=$
(git rev-parse
--sq-quote "$arg") ;;
252 eval bisect_state
'skip' $all
258 check_and_set_terms
$state
261 die
"Please call 'bisect_state' with at least one argument." ;;
262 1,"$TERM_BAD"|
1,"$TERM_GOOD"|
1,skip
)
263 bisected_head
=$
(bisect_head
)
264 rev=$
(git rev-parse
--verify "$bisected_head") ||
265 die
"$(eval_gettext "Bad
rev input
: \
$bisected_head")"
266 bisect_write
"$state" "$rev"
267 git bisect--helper
--check-expected-revs "$rev" ;;
268 2,"$TERM_BAD"|
*,"$TERM_GOOD"|
*,skip
)
273 sha
=$
(git rev-parse
--verify "$rev^{commit}") ||
274 die
"$(eval_gettext "Bad
rev input
: \
$rev")"
275 hash_list
="$hash_list $sha"
277 for rev in $hash_list
279 bisect_write
"$state" "$rev"
281 git bisect--helper
--check-expected-revs $hash_list ;;
283 die
"$(eval_gettext "'git bisect \$TERM_BAD' can take only one argument.
")" ;;
290 bisect_next_check
() {
291 missing_good
= missing_bad
=
292 git show-ref
-q --verify refs
/bisect
/$TERM_BAD || missing_bad
=t
293 test -n "$(git for-each-ref "refs
/bisect
/$TERM_GOOD-*")" || missing_good
=t
295 case "$missing_good,$missing_bad,$1" in
297 : have both
$TERM_GOOD and
$TERM_BAD - ok
300 # do not have both but not asked to fail - just report.
304 # have bad (or new) but not good (or old). we could bisect although
305 # this is less optimum.
306 eval_gettextln
"Warning: bisecting only with a \$TERM_BAD commit." >&2
309 # TRANSLATORS: Make sure to include [Y] and [n] in your
310 # translation. The program will only accept English input
312 gettext "Are you sure [Y/n]? " >&2
314 case "$yesno" in [Nn
]*) exit 1 ;; esac
316 : bisect without
$TERM_GOOD...
319 bad_syn
=$
(bisect_voc bad
)
320 good_syn
=$
(bisect_voc good
)
321 if test -s "$GIT_DIR/BISECT_START"
324 eval_gettextln
"You need to give me at least one \$bad_syn and one \$good_syn revision.
325 (You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
327 eval_gettextln
"You need to start by \"git bisect start\".
328 You then need to give me at least one \$good_syn and one \$bad_syn revision.
329 (You can use \"git bisect \$bad_syn\" and \"git bisect \$good_syn\" for that.)" >&2
336 bisect_next_check
&& bisect_next ||
:
340 case "$#" in 0) ;; *) usage
;; esac
342 bisect_next_check
$TERM_GOOD
344 # Perform all bisection computation, display and checkout
345 git bisect--helper
--next-all $
(test -f "$GIT_DIR/BISECT_HEAD" && echo --no-checkout)
348 # Check if we should exit because bisection is finished
351 bad_rev
=$
(git show-ref
--hash --verify refs
/bisect
/$TERM_BAD)
352 bad_commit
=$
(git show-branch
$bad_rev)
353 echo "# first $TERM_BAD commit: $bad_commit" >>"$GIT_DIR/BISECT_LOG"
357 echo "# only skipped commits left to test" >>"$GIT_DIR/BISECT_LOG"
358 good_revs
=$
(git for-each-ref
--format="%(objectname)" "refs/bisect/$TERM_GOOD-*")
359 for skipped
in $
(git rev-list refs
/bisect
/$TERM_BAD --not $good_revs)
361 skipped_commit
=$
(git show-branch
$skipped)
362 echo "# possible first $TERM_BAD commit: $skipped_commit" >>"$GIT_DIR/BISECT_LOG"
367 # Check for an error in the bisection process
368 test $res -ne 0 && exit $res
374 bisect_next_check fail
378 if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
379 type gitk
>/dev
/null
2>&1
388 -*) set git log
"$@" ;;
393 eval '"$@"' --bisect -- $
(cat "$GIT_DIR/BISECT_NAMES")
397 test -s "$GIT_DIR/BISECT_START" ||
{
398 gettextln
"We are not bisecting."
402 0) branch
=$
(cat "$GIT_DIR/BISECT_START") ;;
403 1) git rev-parse
--quiet --verify "$1^{commit}" >/dev
/null ||
{
405 die
"$(eval_gettext "'\$invalid' is not a valid commit
")"
412 if ! test -f "$GIT_DIR/BISECT_HEAD" && ! git checkout
"$branch" --
414 die
"$(eval_gettext "Could not check out original HEAD
'\$branch'.
415 Try
'git bisect reset <commit>'.
")"
417 git bisect--helper
--bisect-clean-state ||
exit
422 test "$#" -eq 1 || die
"$(gettext "No logfile given
")"
423 test -r "$file" || die
"$(eval_gettext "cannot
read \
$file for replaying
")"
425 while read git bisect
command rev
427 test "$git $bisect" = "git bisect" ||
test "$git" = "git-bisect" ||
continue
428 if test "$git" = "git-bisect"
434 check_and_set_terms
"$command"
437 cmd
="bisect_start $rev"
439 "$TERM_GOOD"|
"$TERM_BAD"|skip
)
440 bisect_write
"$command" "$rev" ;;
444 die
"$(gettext "?? what are you talking about?
")" ;;
451 bisect_next_check fail
456 eval_gettextln
"running \$command"
460 # Check for really bad run error.
461 if [ $res -lt 0 -o $res -ge 128 ]
463 eval_gettextln
"bisect run failed:
464 exit code \$res from '\$command' is < 0 or >= 128" >&2
468 # Find current state depending on run success or failure.
469 # A special exit code of 125 means cannot test.
480 # We have to use a subshell because "bisect_state" can exit.
481 ( bisect_state
$state >"$GIT_DIR/BISECT_RUN" )
484 cat "$GIT_DIR/BISECT_RUN"
486 if sane_grep
"first $TERM_BAD commit could be any of" "$GIT_DIR/BISECT_RUN" \
489 gettextln
"bisect run cannot continue any more" >&2
495 eval_gettextln
"bisect run failed:
496 'bisect_state \$state' exited with error code \$res" >&2
500 if sane_grep
"is the first $TERM_BAD commit" "$GIT_DIR/BISECT_RUN" >/dev
/null
502 gettextln
"bisect run success"
510 test -s "$GIT_DIR/BISECT_LOG" || die
"$(gettext "We are not bisecting.
")"
511 cat "$GIT_DIR/BISECT_LOG"
515 if test -s "$GIT_DIR/BISECT_TERMS"
520 } <"$GIT_DIR/BISECT_TERMS"
524 check_and_set_terms
() {
529 if test -s "$GIT_DIR/BISECT_TERMS" && test "$cmd" != "$TERM_BAD" && test "$cmd" != "$TERM_GOOD"
531 die
"$(eval_gettext "Invalid
command: you
're currently in a \$TERM_BAD/\$TERM_GOOD bisect.")"
535 if ! test -s "$GIT_DIR/BISECT_TERMS"
539 git bisect--helper --write-terms "$TERM_BAD" "$TERM_GOOD" || exit
543 if ! test -s "$GIT_DIR/BISECT_TERMS"
547 git bisect--helper --write-terms "$TERM_BAD" "$TERM_GOOD" || exit
556 bad) echo "bad|new" ;;
557 good) echo "good|old" ;;
563 if ! test -s "$GIT_DIR/BISECT_TERMS"
565 die "$(gettext "no terms defined")"
569 gettextln "Your current terms are $TERM_GOOD for the old state
570 and $TERM_BAD for the new state."
575 --term-good|--term-old)
576 printf '%s
\n' "$TERM_GOOD"
578 --term-bad|--term-new)
579 printf '%s
\n' "$TERM_BAD"
582 die "$(eval_gettext "invalid argument \$arg for 'git bisect terms
'.
583 Supported options are: --term-good|--term-old and --term-bad|--term-new.")"
604 bad|good|new|old|"$TERM_BAD"|"$TERM_GOOD")
605 bisect_state "$cmd" "$@" ;;
609 # Not sure we want "next" at the UI level anymore.
612 bisect_visualize "$@" ;;
616 bisect_replay "$@" ;;